# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_Align
		class Align
			def initialize(alignfix=0)
				@alignfix=alignfix
			end
			def activate
				@e1=[]
				@e2=[]
				@strings=S4U::S4u_Align::Strings
				@alignfix = S4U::S4u_Align::instance_variable_get :@setting
				self.reset(nil)
				model=Sketchup.active_model
				sels=model.selection
				@selected_objects=nil
				@selected_edges=[];@selected_faces=[];@selected_curve=[]
				if !sels.empty?
					objects=[]
					cur=[]
					sels.each{|s|
							if s.is_a?Sketchup::Edge #and !s.curve
									@selected_edges<< s
							elsif s.is_a?Sketchup::Face
									@selected_faces<< s
							elsif s.is_a?Sketchup::Group or s.is_a?Sketchup::ComponentInstance or s.is_a?Sketchup::Image
									objects << s
							end
							if s.is_a?Sketchup::Edge and s.curve
								@selected_curve<<s.curve
							end
					}
					@selected_curve.uniq!
					@selected_objects = objects if not objects.empty?
				end
				self.setstatus(nil)
			end
			def deactivate(view)
				S4U::S4u_Align::instance_variable_set(:@setting,@alignfix)
			end
			def axes_edit_transform
				model=Sketchup.active_model
				return ( Sketchup.version.to_i>=16) ? model.axes.transformation : model.edit_transform
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @selectedge if @selectedge
				bb.add @mouse_position if @mouse_position
				return bb
			end
			def setstatus(view)
				if @align_mode== 1
				  if  not @selectedge1
					if @e1.empty?
						if @alignfix==0
							Sketchup.status_text = @strings.GetString("Select target edge -> align | press TAB -> align+move")
						else
							Sketchup.status_text = @strings.GetString("Select target edge -> align+move | press TAB -> align")
						end
					else
						if @alignfix==0
							  Sketchup.status_text=@strings.GetString("Select aligned edges | press TAB -> align+move")
						else
							Sketchup.status_text=@strings.GetString("Select align+moved edges | press TAB -> align")
						end
					end
				else
					if @selectedge2.empty?
						if @alignfix==0
							Sketchup.status_text = @strings.GetString("Select aligned edges | press TAB -> align+move | press hold Shift -> multiselect | press hold Ctrl(Alt on Mac) -> Copy")
						else
							Sketchup.status_text = @strings.GetString("Select align+moved edges | press TAB -> align | press hold Shift -> multiselect | press hold Ctrl(Alt on Mac) -> Copy")
						end
				   elsif @mulsel==1
						if @alignfix==0
							Sketchup.status_text = @strings.GetString("Select aligned edges | press hold Shift -> multiselect | Double-Click -> finish")
						else
							Sketchup.status_text = @strings.GetString("Select align+moved edges | press hold Shift -> multiselect | Double-Click -> finish")
						end
					end
				end
				elsif @align_mode== 2
					if not @selectface1
						if @e2.empty?
							if @alignfix==0
								Sketchup.status_text = @strings.GetString("Select target face -> align | press TAB -> align+move")
							else
								Sketchup.status_text = @strings.GetString("Select target face -> align+move | press TAB -> align")
							end
						else
							if @alignfix==0
								Sketchup.status_text=@strings.GetString("Select aligned faces | press TAB -> align+move")
							else
								Sketchup.status_text=@strings.GetString("Select align+moved faces | press TAB -> align")
							end
						end
					else
						if @selectface2.empty?
							if @alignfix==0
								Sketchup.status_text = @strings.GetString("Select aligned faces | press TAB -> align+move | press hold Shift for multiselect | press hold Ctrl(Alt on Mac) -> Copy")
							else
								Sketchup.status_text = @strings.GetString("Select align+moved faces | press TAB -> align | press hold Shift for multiselect | press hold Ctrl(Alt on Mac) -> Copy")
							end
						else
						   if @mulsel==1
							  if @alignfix==0
								 Sketchup.status_text = @strings.GetString("Select aligned faces | press hold Shift -> multiselect | Double-Click for finish")
							  else
								 Sketchup.status_text = @strings.GetString("Select align+moved faces | press hold Shift -> multiselect | Double-Click for finish")
							  end
						   end
						end
					end
				elsif (not @selectface1) || (not @selectedge1)
					if @alignfix==0
						if @e1.empty? and @e2.empty?
							Sketchup.status_text=@strings.GetString("Select aligned Edges(or Faces) | press TAB -> align+move") + " | " +@strings.GetString("Select target edge(or face) -> align")
						else
							Sketchup.status_text=@strings.GetString("Select aligned Edges(or Faces) | press TAB -> Opposite Align") + " | " +@strings.GetString("Select target edge(or face) -> align")
						end
					else
						if @e1.empty? and @e2.empty?
							Sketchup.status_text=@strings.GetString("Select align+moved Edges(or Faces) | press TAB -> align") + " | " +@strings.GetString("Select target edge(or face) -> align+move")
						else
							Sketchup.status_text=@strings.GetString("Select align+moved Edges(or Faces) | press TAB -> Opposite Align")+ " | " + @strings.GetString("Select target edge(or face) -> align+move")
						end

					end
				end
				view.invalidate if view
			end
			def draw(view)
				 self.draw_over(view)
				 if @align_mode==1
					self.draw_edge_select(view)
				 elsif @align_mode==2
					self.draw_face_select(view)
				 end
			end
			def draw_edge_select(view)
				view.line_width = 4
				if @selectedge1
					view.drawing_color = "blue"
					view.draw_line(@selectedge1[0],@selectedge1[1])
				end
				if not @pedge2.empty?
					view.drawing_color = "blueviolet"
					@pedge2.each{ |p| view.draw_line(p[0],p[1]) }
				end
			end
			def draw_face_select(view)
				view.line_width = 4
				view.drawing_color = "blue"
				view.draw_polyline(@ps1) if @selectface1
				if not @selectface2.empty?
					view.drawing_color = "blueviolet"
					(0..@selectface2.length-1).each{ |i| view.draw_polyline @ps2[i] }
				end
			end
			def draw_over(view)
				view.drawing_color = "red"
				view.line_width = 4
				if @align_mode!=2 && @selectedge
					view.set_color_from_line(@selectedge[0],@selectedge[1]) if @select_axis
					view.draw_line(@selectedge[0],@selectedge[1])
				elsif @align_mode!=1 && @selectface
					view.draw_polyline @ps
				end
			end
			def get_bounds(element)
				a=element.transformation.to_a
				b=nil
				if element.is_a?Sketchup::ComponentInstance
					b=element.definition.bounds
				elsif element.is_a?Sketchup::Group
					b=element.local_bounds
				else
					return nil
				end
				return (0..7).collect{|i| b.corner(i).clone.transform! element.transformation } if b
			end
			def select_boundingbox(ip,x,y,view)
				model=Sketchup.active_model
				entities=model.active_entities
				position=Geom::Point3d.new(x,y,0)
				#view=model.active_view
				gc=entities.select{|e| ((e.is_a?Sketchup::Group) || (e.is_a?Sketchup::ComponentInstance)) &&
										(view.screen_coords(e.bounds.center).distance(position) <
										view.screen_coords(e.bounds.center).distance(view.screen_coords(e.bounds.max))*1.5) &&
										e.layer.visible?
										#e.bounds.center.distance(ip.position) < e.bounds.diagonal*0.7
				}.sort_by{|e| e.bounds.center.distance(ip.position) }
				gc=gc[0..7]
				edges=[]
				gc.each{|e|
					bounds=get_bounds(e)
					eds=[
					[bounds[0],bounds[1]],[bounds[0],bounds[2]],[bounds[0],bounds[4]],
					[bounds[1],bounds[3]],[bounds[1],bounds[5]],
					[bounds[2],bounds[3]],[bounds[2],bounds[6]],
					[bounds[3],bounds[7]],
					[bounds[4],bounds[5]],[bounds[4],bounds[6]],
					[bounds[5],bounds[7]],[bounds[6],bounds[7]],
					[Geom.linear_combination(0.5,bounds[0],0.5,bounds[1]),Geom.linear_combination(0.5,bounds[2],0.5,bounds[3])],
					[Geom.linear_combination(0.5,bounds[0],0.5,bounds[1]),Geom.linear_combination(0.5,bounds[4],0.5,bounds[5])],
					[Geom.linear_combination(0.5,bounds[4],0.5,bounds[5]),Geom.linear_combination(0.5,bounds[6],0.5,bounds[7])],
					[Geom.linear_combination(0.5,bounds[6],0.5,bounds[7]),Geom.linear_combination(0.5,bounds[2],0.5,bounds[3])],

					[Geom.linear_combination(0.5,bounds[0],0.5,bounds[2]),Geom.linear_combination(0.5,bounds[1],0.5,bounds[3])],
					[Geom.linear_combination(0.5,bounds[1],0.5,bounds[3]),Geom.linear_combination(0.5,bounds[5],0.5,bounds[7])],
					[Geom.linear_combination(0.5,bounds[5],0.5,bounds[7]),Geom.linear_combination(0.5,bounds[4],0.5,bounds[6])],
					[Geom.linear_combination(0.5,bounds[4],0.5,bounds[6]),Geom.linear_combination(0.5,bounds[0],0.5,bounds[2])],

					[Geom.linear_combination(0.5,bounds[0],0.5,bounds[4]),Geom.linear_combination(0.5,bounds[1],0.5,bounds[5])],
					[Geom.linear_combination(0.5,bounds[1],0.5,bounds[5]),Geom.linear_combination(0.5,bounds[3],0.5,bounds[7])],
					[Geom.linear_combination(0.5,bounds[3],0.5,bounds[7]),Geom.linear_combination(0.5,bounds[2],0.5,bounds[6])],
					[Geom.linear_combination(0.5,bounds[2],0.5,bounds[6]),Geom.linear_combination(0.5,bounds[0],0.5,bounds[4])]
					]
					eds.select!{|ed| ed[0].distance(ed[1])>0}
					eds.map!{|ed| [ed,e] }
					edges+=eds
				}
				edges.sort_by!{|e| view.screen_coords(ip.position).distance_to_line([view.screen_coords(e[0][0]),view.screen_coords(e[0][1])]) }
				e=edges[0]
				return e if e && (view.screen_coords(ip.position).distance_to_line([view.screen_coords(e[0][0]),view.screen_coords(e[0][1])]) < 7)
				return nil
			end
			def onMouseMove(flags, x, y, view)
				ip = view.inputpoint x, y
				@mouse_position=ip.position
				selectedge=ip.edge
				selectface=ip.face
				trans=ip.transformation
				ph = view.pick_helper
				ph.do_pick x,y
				element = ph.best_picked
				tedit=axes_edit_transform
				ip1 = view.inputpoint(x, y,Sketchup::InputPoint.new(tedit.origin))
				p=ip1.position.transform tedit.inverse
				@ps=[];@selectface=nil;@selectedge=nil;@select_axis=nil
				if @align_mode==1 and selectedge#.is_a?Sketchup::Edge
					pstart=selectedge.start.position.clone.transform! trans
					pend=selectedge.end.position.clone.transform! trans
					@selectedge=[pstart,pend]
					@element=element
					view.tooltip=@strings.GetString("Edge")
				elsif @align_mode==2 and selectface
					ps=selectface.outer_loop.vertices.collect{|p| p.position.transform trans }
					ps<< ps[0]
					if Geom.point_in_polygon_2D(ip.position, ps, true )
						@ps=ps
						@selectface=selectface
						@trans=trans
						@element=element
					end
					view.tooltip=@strings.GetString("Face")
				elsif selectedge#.is_a?Sketchup::Edge
					pstart=selectedge.start.position.clone.transform! trans
					pend=selectedge.end.position.clone.transform! trans
					@selectedge=[pstart,pend]
					@element=element
					view.tooltip=@strings.GetString("Edge")
				elsif (bd=select_boundingbox(ip,x,y,view)) && bd && (@align_mode==0 || @align_mode==1)
					@selectedge,@element=bd
					view.tooltip=@strings.GetString("BoundingBox")
				elsif element.is_a?(Sketchup::ConstructionLine) && (@align_mode==0 || @align_mode==1)
					vector = element.direction
					length= view.pixels_to_model 100, ORIGIN
					if vector.length>0
						vector.length=length
						pstart=ip.position.clone + vector
						pend=ip.position.clone + vector.reverse
						@selectedge=[pstart,pend]
						@element=element
					end
					view.tooltip=@strings.GetString("ConstructionLine")
				elsif ((p.x==0 && p.y==0) || (p.x==0 && p.z==0) || (p.y==0 && p.z==0)) && (@align_mode==0 || @align_mode==1)
					@select_axis=true
					vector =tedit.origin.vector_to ip1.position
					length= view.pixels_to_model 100, ORIGIN
					if vector.length>0
						vector.length=length
						pstart=ip1.position.clone + vector
						pend=ip1.position.clone + vector.reverse
						@selectedge=[pstart,pend]
						@element=element
					end
					view.tooltip=@strings.GetString("Axis")
				elsif selectface
					ps=selectface.outer_loop.vertices.collect{|p| p.position.transform trans }
					ps<< ps[0]
					if Geom.point_in_polygon_2D(ip.position, ps, true )
						@ps=ps
						@selectface=selectface
						@trans=trans
						@element=element
					end
					view.tooltip=@strings.GetString("Face")
				end
				self.setstatus(view)
			end
			def onLButtonDoubleClick(flags, x, y, view)
				self.align_edgeonedge if @selectedge1 && (not @selectedge2.empty?) && @align_mode==1 && @mulsel==1
				self.align_faceonface if @selectface1 && (not @selectface2.empty?) && @align_mode==2 && @mulsel==1
				self.setstatus(view)
			end
			def onLButtonDown(flags, x, y, view)
					@mulsel= 1  if @shift_down_time && (not @selected_objects)
					if @align_mode==0
						if @selectedge || (@element and @element.is_a?Sketchup::ConstructionLine) || @select_axis
							@align_mode=1
							@ctrl_down_time=true if (flags & 9)==9
						elsif @selectface.is_a?Sketchup::Face
							@ctrl_down_time=true if (flags & 9)==9
							@align_mode=2
						end
					end
					if @align_mode==1
						if @selectedge
							if @selectedge1
								if @selected_objects && (not @element2.include? @selected_objects)
									@element2<< @selected_objects
									@selectedge2<< @selectedge
									@pedge2 << @selectedge
								elsif (@selectedge2.empty? || (@mulsel==1 && @selecting)) && @element && ((@element.is_a?Sketchup::Group) || (@element.is_a?Sketchup::ComponentInstance) || (@element.is_a?Sketchup::Edge)|| (@element.is_a?Sketchup::Image) )
									if @element2.include? @element
										index=@element2.index(@element)
										@element2.delete_at(index)
										@selectedge2.delete_at(index)
										@pedge2.delete_at(index)
									else
										@element2<< @element
										@selectedge2<< @selectedge
										@pedge2 << @selectedge
									end
								end
							else
								@e1=[] ;@e2=[]
								@selectedge1=@selectedge
								@ray = view.pickray x, y
							end
						else
							@align_mode==0
						end
					elsif @align_mode==2
						if @selectface.is_a?Sketchup::Face
							if @selectface1
								if @selected_objects && (not @element2.include? @selected_objects)
									@element2<< @selected_objects
									@selectface2<< @selectface
									@transface2<< @trans
									@ps2<< @ps
								elsif @selectface2.empty? || (@mulsel==1 && @selecting)
									if @element2.include? @element
										index=@element2.index(@element)
										@element2.delete_at(index)
										@selectface2.delete_at(index)
										@transface2.delete_at(index)
										@ps2.delete_at(index)
									else
										@element2<< @element
										@selectface2<< @selectface
										@transface2<< @trans
										@ps2<< @ps
									end
								end
							else
								@e2=[];@e1=[];@ps1=[]
								@selectface1=@selectface
								@transface1=@trans
								@ps1=@ps
							end # end else
						else
							@align_mode==0
						end
					end #else
			end
			def getMenu(menu)
				align_mode=[]
				align_mode<<menu.add_item(@strings.GetString("Align Edge-Face")) { @align_mode=0 }
				align_mode<<menu.add_item(@strings.GetString("Align Edge")) { @align_mode=1 }
				align_mode<<menu.add_item(@strings.GetString("Align Face")) { @align_mode=2 }
				align_mode.each{|m| menu.set_validation_proc(m){ MF_UNCHECKED}}
				menu.set_validation_proc(align_mode[@align_mode]){ MF_CHECKED} #if @align_mode>0
				menu.add_separator
				align_mode=[]
				align_mode<<menu.add_item(@strings.GetString("Align")) { @alignfix=0 }
				align_mode<<menu.add_item(@strings.GetString("Align-Move")) { @alignfix=1 }
				align_mode.each{|m| menu.set_validation_proc(m){ MF_UNCHECKED}}
				menu.set_validation_proc(align_mode[@alignfix]){ MF_CHECKED}
				menu.add_separator
				item=menu.add_item(@strings.GetString("Opposite Align")) {
				  	if !@e1.empty?
						self.rotate_elements_edge
					elsif !@e2.empty?
						self.rotate_elements_face
					end
				}
				menu.set_validation_proc(item){
					if  (@e1+@e2).flatten.any?{|element2| element2.is_a?(Sketchup::Group) || element2.is_a?(Sketchup::ComponentInstance) || element2.is_a?(Sketchup::Image) }
						MF_ENABLED
					else
						MF_GRAYED
					end
				}
			end
			def normal_face(ver)
				vx=nil;vy=nil;line=nil
				(0..ver.length-2).each{|i|
					vx=ver[i].vector_to ver[i+1]
					line=ver[i],ver[i+1]
					break if vx.length!=0
				}
				if line
					(0..ver.length-1).each{|i|
						v2=ver[i].project_to_line line
						vy=v2.vector_to ver[i]
						break if vy.length!=0
					}
					return (vx.cross vy) if vx && vy
				end
				Sketchup.active_model.select_tool(nil)
			end
			def onLButtonUp(flags, x, y, view)
				if  @align_mode==1 && @selectedge1
					if @selected_edges.empty?
						self.align_edgeonedge if (not @selectedge2.empty?) && @mulsel==0
					else
						@selected_edges.each{|e|
							@selectedge2<< e
							@element2<< e
							@pedge2<< [e.start.position,e.end.position]
						}
						self.align_edgeonedge if !@selected_objects
						view.model.selection.clear
						@selected_edges.clear
						@selected_faces.clear
					end
				elsif @align_mode==2 && @selectface1
					if @selected_faces.empty?
						self.align_faceonface if (not @selectface2.empty?) && @mulsel==0
					else
					tedit=axes_edit_transform
					@selected_faces.each{|e|
						@selectface2<< e
						@element2<< e
						ps=(e.outer_loop.vertices.collect{|p| p.position.transform tedit } )
						ps<< ps[0]
						@ps2<< ps
						@transface2<< tedit
					}
					self.align_faceonface if !@selected_objects
					view.model.selection.clear
					@selected_edges.clear
					@selected_faces.clear
					end
				end
				self.setstatus(view)
			end
			def rotate_elements_face
				model = Sketchup.active_model
				entities = model.active_entities
				model.start_operation @strings.GetString("Align Face-Opposite"),true,false,false
				(0..@e2.length-1).each{|i|
					element=@e2[i];cen=@center[i]
					element_array = (element.class == Array)
					element=[element] if !element_array
					element.each{|e|
						if e.valid? && (e.is_a?Sketchup::Group or e.is_a?Sketchup::ComponentInstance or e.is_a?Sketchup::Image) && cen && @zaxis
							new_transform = Geom::Transformation.new(cen,@zaxis)
							t=e.transformation
							te=new_transform.inverse*t
							t=Geom::Transformation.new(cen,@zaxis.reverse)
							e.transformation=t*te
						end
					}
				}
				model.commit_operation
			end
			def rotate_elements_edge
				model = Sketchup.active_model
				entities = model.active_entities
				model.start_operation @strings.GetString("Align Egde-Opposite"),true,false,false
				(0..@e1.length-1).each{|i|
					element=@e1[i];cen=@center[i]
					element_array = (element.class == Array)
					element=[element] if !element_array
					element.each{|e|
						if e.valid? && (e.is_a?Sketchup::Group or e.is_a?Sketchup::ComponentInstance or e.is_a?Sketchup::Image) && cen && @zaxis
							new_transform = Geom::Transformation.new(cen,@zaxis)
							t=e.transformation
							et=new_transform.inverse*t
							t=Geom::Transformation.new(cen,@zaxis.reverse)
							e.transformation = t*et
						end
					}
				}
				model.commit_operation
			end
			def onKeyDown(key, repeat, flags, view)
				if ((key==VK_SHIFT) && IS_WIN ) || ((key==VK_SHIFT) && IS_OSX)
					@shift_down_time=true
					@selecting=true
				elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
					@ctrl_down_time=true
				elsif ((key==VK_ALT) && IS_WIN ) || ((key==VK_CONTROL) && IS_OSX)
					@alt_press=true
				elsif (key==VK_UP)
					@lock_axis= @lock_axis==Z_AXIS ? nil : Z_AXIS
				elsif (key==VK_RIGHT)
					@lock_axis=@lock_axis==X_AXIS ? nil : X_AXIS
				elsif (key==VK_LEFT)
					@lock_axis=@lock_axis==Y_AXIS ? nil : Y_AXIS
				end
			end
			def onKeyUp(key, repeat, flags, view)
				if ((key==VK_SHIFT) && IS_WIN ) || ((key==VK_SHIFT) && IS_OSX)
					@shift_down_time=nil
					@selecting=false
				elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
					@ctrl_down_time=nil
				elsif ((key==VK_ALT) && IS_WIN ) || ((key==VK_CONTROL) && IS_OSX)
					@alt_press=nil
				elsif key==13
					self.align_edgeonedge if @selectedge1 and @selectedge2.length>0 and @align_mode==1 and @mulsel == 1
					self.align_faceonface if @selectface1 and @selectface2.length>0 and @align_mode==2 and @mulsel == 1
					#self.setstatus(view)
				elsif (key==VK_DOWN )
					if not @e1.empty?
						self.rotate_elements_edge
					elsif not @e2.empty?
						self.rotate_elements_face
					end
				elsif ((key==9) && IS_WIN ) || ((key==48) && IS_OSX)
					if not @e1.empty?
						self.rotate_elements_edge
					elsif not @e2.empty?
						self.rotate_elements_face
					elsif
						@alignfix=1-@alignfix
					end
				end
				self.setstatus(view)
			end
			def align_edgeonedge
				model = Sketchup.active_model
				entities = model.active_entities
				model.start_operation @strings.GetString("Align Edge"),true,false,false
				@e1=[]
				cp1start=@selectedge1[0]
				cp1end=@selectedge1[1]
				v1=(cp1start.vector_to cp1end)
				v1clone=v1.clone
				line = [cp1start,cp1end]
				midedge1=Geom::Point3d.new( (cp1start.x+cp1end.x)/ 2,(cp1start.y+cp1end.y)/ 2,(cp1start.z+cp1end.z)/ 2)
				@e1=@element2;
				@center=[];@sub_entities=[];@vector_array=[]
				@zaxis=v1
				if !@selected_curve.empty?
					curs=@selected_curve
					curs.uniq!
					if @ray &&([X_AXIS,Y_AXIS,Z_AXIS].find{|vz| @ray[1].parallel?(vz)})
						vz=@ray[1].cross(v1)
						if vz.length>0
							plane1=[midedge1,vz]
							pstart= cp2start.project_to_plane plane1
							pend = cp2end.project_to_plane plane1
							mid=Geom::Point3d.new( (pstart.x+pend.x)/ 2,(pstart.y+pend.y)/ 2,(pstart.z+pend.z)/ 2)
							v_mid=midedge1-mid
							if pstart==pend
								pl=[cp1start,@ray[1]]
								ps=cp1start.project_to_plane(pl)
								pe=cp1end.project_to_plane(pl)
								v=ps.vector_to(pe)
								cp1start=pstart
								cp1end= cp1start + v
							else
								cp1start= pstart
								cp1end = pend
							end
							if cp1start!=cp1end
								if @alignfix==1 and v_mid.length!=0
									cp1end=cp1end + v_mid
									cp1start=cp1start + v_mid
								end
								v1=cp1start.vector_to cp1end
								line = [cp1start,cp1end]
								midedge1=Geom::Point3d.new( (cp1start.x+cp1end.x)/ 2,(cp1start.y+cp1end.y)/ 2,(cp1start.z+cp1end.z)/ 2)
							end
						end
					end
					curs.each{|cur|
						cp2start=cur.vertices[0].position
						if cur.vertices[-1]==cur.vertices[0]
							cp2start= (cur.vertices.collect{|e| e.position}).sort_by{|v| v.distance_to_line line}[0]
							vec=(line[1]-line[0]);vec.length=1
							cp2end=cp2start+vec
						else
							cp2end=cur.vertices[-1].position
						end
						points=[]
						pointonline1 = cp2start.project_to_line line
						pointonline2 = cp2end.project_to_line line
						if pointonline2==pointonline1
							vec=(line[1]-line[0]);vec.length= cp2start.distance cp2end
							(pointonline2=pointonline1+vec)
						end
						v1=nil,v2=nil
						if @alignfix==1 and (not ((@element and @element.is_a?Sketchup::ConstructionLine) || @select_axis))
							trans1=Geom::Transformation.new(midedge1,(pointonline1.vector_to pointonline2))
							trans2=Geom::Transformation.new cp2start,(cp2start.vector_to cp2end)
							v1 = cp2start.vector_to cp2start.transform(trans1*trans2.inverse)
							v2 = cp2end.vector_to cp2end.transform(trans1*trans2.inverse)
						else
							trans1=Geom::Transformation.new pointonline1,(pointonline1.vector_to pointonline2)
							trans2=Geom::Transformation.new cp2start,(cp2start.vector_to cp2end)
							v1 = cp2start.vector_to pointonline1
							v2 = cp2end.vector_to pointonline2
						end
						cur.vertices.each{|v|
							points<< v.position.transform(trans1*trans2.inverse)
						}
						if @ctrl_down_time
							c=entities.add_curve points
							c.each{|e| e.layer=cur.edges[0].layer} if c
						else
							cur.move_vertices points
						end
					}
				end
				(0..@selectedge2.length-1).each{ |i|
					v1=v1clone
					pe2=@pedge2[i]
					element=@element2[i]
					element_array=(element.class == Array)
					element=[element] if !element_array
					element.each_index{|id|
						element2=element[id]
						selectedge2=@selectedge2[i]
						cp2start=pe2[0]
						cp2end=pe2[1]
						begin
						if (@ray && ([X_AXIS,Y_AXIS,Z_AXIS].find{|vz| @ray[1].parallel?(vz)} ) )|| @alt_press || @lock_axis
							vz=@ray[1].cross(v1) if @ray
							if @alt_press
								vz=Z_AXIS.cross(v1)
							elsif @lock_axis
								vz=@lock_axis.cross(v1)
								p @lock_axis
							end
							if vz.length>0
								plane1=[midedge1,vz]
								pstart= cp2start.project_to_plane plane1
								pend = cp2end.project_to_plane plane1
								mid= Geom::Point3d.new( (pstart.x+pend.x)/ 2,(pstart.y+pend.y)/ 2,(pstart.z+pend.z)/ 2)
								v_mid= midedge1-mid
								if pstart==pend
									pl=[cp1start,@ray[1]]
									ps=cp1start.project_to_plane(pl)
									pe=cp1end.project_to_plane(pl)
									v=ps.vector_to(pe)
									cp1start=pstart
									cp1end= cp1start + v
								else
									cp1start= pstart
									cp1end = pend
								end
								if cp1start!=cp1end
									if @alignfix==1 and v_mid.length!=0
										cp1end=cp1end + v_mid
										cp1start=cp1start + v_mid
									end
									v1=cp1start.vector_to cp1end
									line = [cp1start,cp1end]
									midedge1=Geom::Point3d.new( (cp1start.x+cp1end.x)/ 2,(cp1start.y+cp1end.y)/ 2,(cp1start.z+cp1end.z)/ 2)
								end
							end
						end
						rescue =>error
							p error
						end
						if element2 && element2.valid?# && element2.is_a?(Sketchup::Drawingelement)
							if element2.is_a?(Sketchup::Group) || element2.is_a?(Sketchup::ComponentInstance) || element2.is_a?(Sketchup::Image)
								if @ctrl_down_time
									if element2.is_a?(Sketchup::Group)
										attributes=S4U::S4u_Align.get_attribute_element(element2)
										element2=element2.copy
										S4U::S4u_Align::set_attribute_element(element2,attributes)
									elsif element2.is_a?(Sketchup::ComponentInstance)
										attributes=S4U::S4u_Align.get_attribute_element(element2)
										element2=entities.add_instance(element2.definition,element2.transformation)
										S4U::S4u_Align.set_attribute_element(element2,attributes)
									elsif element2.is_a?(Sketchup::Image)
										t=element2.transformation
										attributes=S4U::S4u_Align.get_attribute_element(element2)
										element2=entities.add_image(element2.path,element2.origin,element2.width,element2.height)
										S4U::S4u_Align.set_attribute_element(element2,attributes)
										element2.transformation=t
									end
									if element_array
										@e1[i][id]=element2
									else
										@e1[i]=element2
									end
								end
								midedge2=Geom::Point3d.new( (cp2start.x+cp2end.x)/ 2,(cp2start.y+cp2end.y)/ 2,(cp2start.z+cp2end.z)/ 2)
								v2=cp2start.vector_to cp2end
								new_transform2 = Geom::Transformation.new(midedge2,v2)
								t=element2.transformation
								et=new_transform2.inverse*t
								pointonline1 = cp2start.project_to_line line
								pointonline2 = cp2end.project_to_line line
								midonline=midedge2.project_to_line line
								v3= (pointonline1==pointonline2) ? v1 : (pointonline1.vector_to pointonline2)
								angle=v2.angle_between v3
								new_transform3 = (@alignfix==1) ?  Geom::Transformation.new(midedge1,v3) : Geom::Transformation.new(midonline,v3)
								@center[i]=new_transform3.origin
								element2.transformation=new_transform3*et
							else#if (element2.is_a?( Sketchup::Edge))
								element2=element2.curve if ((element2.is_a?( Sketchup::Edge)) and element2.curve)
								if element2.is_a?(Sketchup::Curve) and (not @selected_curve.include?(element2))
									curs=[]
									curs <<element2 if element2.is_a?(Sketchup::Curve)
									curs.uniq!
									curs.each{|cur|
										points=[]
										midedge2=Geom::Point3d.new((cp2start.x+cp2end.x)/ 2,(cp2start.y+cp2end.y)/ 2,(cp2start.z+cp2end.z)/ 2)
										pointonline1 = cp2start.project_to_line line
										pointonline2 = cp2end.project_to_line line
										if pointonline2==pointonline1
											vec=(line[1]-line[0]);vec.length=element2.length
											(pointonline2=pointonline1+vec)
										end
										v1=nil,v2=nil
										if @alignfix==1 and (not ((@element and @element.is_a?Sketchup::ConstructionLine) || @select_axis))
											trans1=Geom::Transformation.new(midedge1,(pointonline1.vector_to pointonline2))
											trans2=Geom::Transformation.new midedge2,(cp2start.vector_to cp2end)
											v1 = cp2start.vector_to cp2start.transform(trans1*trans2.inverse)
											v2 = cp2end.vector_to cp2end.transform(trans1*trans2.inverse)
										else
											trans1=Geom::Transformation.new pointonline1,(pointonline1.vector_to pointonline2)
											trans2=Geom::Transformation.new cp2start,(cp2start.vector_to cp2end)
											v1 = cp2start.vector_to pointonline1
											v2 = cp2end.vector_to pointonline2
										end
										cur.vertices.each{|v|
											points<< v.position.transform(trans1*trans2.inverse)
										}
										if @ctrl_down_time
											c=entities.add_curve points
											c.each{|e| e.layer=cur.edges[0].layer} if c
										else
											cur.move_vertices points
										end
									}
								elsif element2.is_a?( Sketchup::Edge)

									midedge2=Geom::Point3d.new((cp2start.x+cp2end.x)/ 2,(cp2start.y+cp2end.y)/ 2,(cp2start.z+cp2end.z)/ 2)
									pointonline1 = cp2start.project_to_line line
									pointonline2 = cp2end.project_to_line line
									if pointonline2==pointonline1
										vec=(line[1]-line[0]);vec.length=element2.length
										(pointonline2=pointonline1+vec)
									end
									v1=nil,v2=nil
									if @alignfix==1 and (not ((@element and @element.is_a?Sketchup::ConstructionLine) || @select_axis))
										trans1=Geom::Transformation.new(midedge1,(pointonline1.vector_to pointonline2))
										trans2=Geom::Transformation.new midedge2,(cp2start.vector_to cp2end)
										v1 = cp2start.vector_to cp2start.transform(trans1*trans2.inverse)
										v2 = cp2end.vector_to cp2end.transform(trans1*trans2.inverse)
									else
										trans1=Geom::Transformation.new pointonline1,(pointonline1.vector_to pointonline2)
										trans2=Geom::Transformation.new cp2start,(cp2start.vector_to cp2end)
										v1 = cp2start.vector_to pointonline1
										v2 = cp2end.vector_to pointonline2
									end
									if  @ctrl_down_time or ( element2.vertices.all?{|v| not v.edges.any?{|e| e.curve}}) or
										not @selected_edges.include?(element2)
										if not @sub_entities.include?(element2.vertices[0])
											@sub_entities << element2.vertices[0]
											@vector_array << v1
										end
										if not @sub_entities.include?(element2.vertices[1])
											@sub_entities << element2.vertices[1]
											@vector_array << v2
										end
									end
								end
							end
						end
					}
				}
				if  @ctrl_down_time
					lines=[]
					@sub_entities.each_index{|i| lines << (@sub_entities[i].position+@vector_array[i])}
					lines.each_index{|i|
						if  (i<lines.length-1)
							ed=((@sub_entities[i].edges & (@sub_entities[i+1]).edges)&@element2)[0]
							if ed and ed.length>=1
								l=entities.add_line lines[i],lines[i+1]
								l.layer=ed.layer if l
							end
						end
					}
				else
					entities.transform_by_vectors @sub_entities, @vector_array
				end
				self.reset
				model.commit_operation
			end
			def align_faceonface
				model = Sketchup.active_model
				entities = model.active_entities
				model.start_operation @strings.GetString("Align Face"),true,false,false
				@e2=[]
				@zaxis=self.normal_face(@ps1)
				cp1=self.centerface(@selectface1)
				cp1.transform! @transface1
				new_transform1 = Geom::Transformation.new(cp1,@zaxis)
				plane = [cp1,@zaxis]
				@e2=@element2;@center=[]  ;@sub_entities=[]; @vector_array=[]
				(0..@selectface2.length-1).each{ |i|
					element=@element2[i]
					element_array=(element.class == Array)
					element=[element] if !element_array
					element.each_index{|id|
						element2=element[id]
						selectface2=@selectface2[i]
						transface2=@transface2[i]
						ps2=@ps2[i]
						if selectface2.is_a?Sketchup::Face
							if element2.is_a?(Sketchup::Group) || element2.is_a?(Sketchup::ComponentInstance) || element2.is_a?(Sketchup::Image)
								if @ctrl_down_time
									if element2.is_a?(Sketchup::Group)
										attributes=S4U::S4u_Align.get_attribute_element(element2)
										element2=element2.copy
										S4U::S4u_Align.set_attribute_element(element2,attributes)
									elsif element2.is_a?(Sketchup::ComponentInstance)
										attributes=S4U::S4u_Align.get_attribute_element(element2)
										element2=entities.add_instance(element2.definition,element2.transformation)
										S4U::S4u_Align.set_attribute_element(element2,attributes)
									elsif element2.is_a?(Sketchup::Image)
										t=element2.transformation
										attributes=S4U::S4u_Align.get_attribute_element(element2)
										element2=entities.add_image(element2.path,element2.origin,element2.width,element2.height)
										S4U::S4u_Align.set_attribute_element(element2,attributes)
										element2.transformation=t
									end
									if element_array
										@e2[i][id]=element2
									else
										@e2[i]=element2
									end
								end
								cp2=self.centerface(selectface2)
								cp2.transform! transface2
								v2= self.normal_face(ps2)
								normalface2=selectface2.normal
								normalface2.transform! transface2
								v2.reverse! if (v2.angle_between normalface2)>= Math::PI/ 2
								new_transform2 = Geom::Transformation.new(cp2,v2)
								t=element2.transformation
								te=new_transform2.inverse*t
								pointonplane = cp2.project_to_plane plane
								new_transform3 = @alignfix==1 ? Geom::Transformation.new(cp1,@zaxis) : Geom::Transformation.new(pointonplane,@zaxis)
								@center[i] =new_transform3.origin
								element2.transformation=new_transform3*te
							elsif element2.is_a?Sketchup::Face
								if @ctrl_down_time
									g=entities.add_group selectface2
									g_new=g.copy
									g.explode
									selectface2=g_new.entities.select{|e| e.is_a?Sketchup::Face}[0]
									curves=[]
									selectface2.edges.each{|e| curves<<e.curve if (e.is_a?Sketchup::Edge and e.curve and (not curves.include?(e.curve))) }
									curves.uniq!
									curs=[]
									curves.each{|cur|
										points=[]
										cur.vertices.each{|p|
											if selectface2.valid? and (selectface2.vertices.include? p)
												points <<  (p.position.transform(g_new.transformation).project_to_plane plane).transform(g_new.transformation.inverse)
											end
										}
										if points.length==cur.vertices.length
											curs<<[cur,points]
										else
											cur.first_edge.explode_curve
										end
									}
									vcur=[]
									vcur=curs.transpose[0].collect{|c| c.vertices}.flatten if !curs.empty?
									sub_entities=[]
									vector_array=[]
									#plane1=[plane[0].transform(g_new.transformation.inverse),plane[1].transform(g_new.transformation.inverse)]
									selectface2.vertices.each{|ver2|
										if (curs.empty?) or (!vcur.include?(ver2))
											p=ver2.position.transform(g_new.transformation)
											p1 = p.project_to_plane plane
											v=p.vector_to p1
											if (not sub_entities.include?(ver2))
												sub_entities << ver2
												vector_array << v#.transform(g_new.transformation)
											end
										end
									}
									curs.each{|c| c[0].move_vertices c[1]} if !curs.empty?
									g_new.entities.transform_by_vectors sub_entities, vector_array
									g_new.explode
								else
									curves=[]
									selectface2.edges.each{|e| curves<<e.curve if (e.is_a?Sketchup::Edge and e.curve and (not curves.include?(e.curve))) }
									curves.uniq!
									curs=[]
									curves.each{|cur|
										points=[]
										cur.vertices.each{|p|
											if selectface2.valid? and (selectface2.vertices.include? p)
												points <<  (p.position.project_to_plane plane)
											end
										}
										if points.length==cur.vertices.length
											curs<<[cur,points]
										else
											cur.first_edge.explode_curve
										end
									}
									vcur=curs.transpose[0].collect{|c| c.vertices}.flatten if !curs.empty?
									selectface2.vertices.each{|ver2|
										if (curs.empty?) or (!vcur.include?(ver2))
											p=ver2.position
											p1 = p.project_to_plane plane
											v=p.vector_to p1
											if (not @sub_entities.include?(ver2))
												@sub_entities << ver2
												@vector_array << v
											end
										end
									}
									curs.each{|c| c[0].move_vertices c[1]} if !curs.empty?
								end
							end
						end
					}
				}
				if  !@ctrl_down_time
					entities.transform_by_vectors @sub_entities, @vector_array
				end
				self.reset
				model.commit_operation
			end
			def onCancel(reason, view)
				@e1.clear;@e2.clear
				self.reset(view)
			end
			def reset(view=nil)
				@align_mode=0
				@mulsel=0
				@shift_down_time=nil
				@ctrl_down_time=nil
				@selectface1=nil
				@selectface2=[]
				@element1=nil
				@element2=[]
				@selectface=nil
				@trans=nil
				@transface1=nil
				@transface2=[]
				@ps2=[];@ps1=[]
				@selectedge1=nil
				@selectedge2=[]
				@selectedge=nil
				@pedge2=[]
				@ray=nil
				self.setstatus(view)
			end
			def centerface(fa)
				cp=Geom::Point3d.new
				if fa.is_a?Sketchup::Face
					numver=fa.outer_loop.vertices.length
					fa.outer_loop.vertices.each{|v|
					cp.x=cp.x+v.position.x
					cp.y=cp.y+v.position.y
					cp.z=cp.z+v.position.z
				}
				cp.x=cp.x/ numver
				cp.y=cp.y/ numver
				cp.z=cp.z/ numver
				end
				return cp
			end
			def resume(view)
				self.setstatus(view)
			end
		end
		def self.get_attribute_element(element)
			return {"layer"=>element.layer,"hidden"=>element.hidden?,"material"=>element.material,
					"casts_shadows"=>element.casts_shadows?,"receives_shadows"=>element.receives_shadows?}
		end
		def self.set_attribute_element(element,hash)
			hash.each{|k,v|
				if k=="layer"
					element.layer=v
				elsif k=="hidden"
					element.hidden=v
				elsif k=="material"
					element.material=v
				elsif k=="casts_shadows"
					element.casts_shadows=v
				elsif k=="receives_shadows"
					element.receives_shadows=v
				end
			}
			return element
		end
		def self.align
			@setting=0 if !@setting
			Sketchup.active_model.select_tool Align.new
		end
	end
end